/* Procedure para gerao de contas a receber

PARA DEBUGAR PROCEDURE
RAISERROR('', 16,1);

@C:\web_560\sql\end_conv\sqlserver\0008_GERSTPS_APURAC_VENC.sql
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'APURAC_VENC'    AND
	        TYPE   = 'P'              AND
	        U.UID  = O.UID            AND
	        U.NAME = USER)
  DROP PROCEDURE APURAC_VENC
  GO
CREATE PROCEDURE APURAC_VENC
   @P_CDFILIAL   VARCHAR(04),
   @P_CDCLIENTE  VARCHAR(21),
   @P_NRLANCTONF VARCHAR(10)
AS
BEGIN
   DECLARE @V_CDFILIALPED    VARCHAR(04);
   DECLARE @V_NRPEDIDO       VARCHAR(10);
   DECLARE @V_FORMPGTOCL     VARCHAR(01);
   DECLARE @V_PARCPGTOCL     INTEGER;
   DECLARE @V_VRNOTAFISC     FLOAT;
   DECLARE @V_CDINTEGRACAO   VARCHAR(16);
   DECLARE @V_ORIGDESTNF     VARCHAR(01);
   DECLARE @V_ENTRSAIDOP     VARCHAR(01);
   DECLARE @V_VRIMPORETI     INTEGER;
   DECLARE @V_SEQUENCIAL     INTEGER;
   DECLARE @V_VRPARCVENC     FLOAT;
   DECLARE @V_VRPARCAUXI     FLOAT;
   DECLARE @V_NRPARCELAS     INTEGER;
   DECLARE @V_CDSERVCONT     VARCHAR(05);
   DECLARE @V_DSREFSERVFAT   VARCHAR(30);
   DECLARE @V_CDFILIALDUP    VARCHAR(04);
   DECLARE @V_NRLANCTODUP    VARCHAR(10);
   DECLARE @V_VRCONTARECE    FLOAT;
   DECLARE @V_VRIMPOSRETI    FLOAT;
   DECLARE @V_ARAJUSTEDUP    FLOAT;
   DECLARE @V_CDAJUCTREC     VARCHAR(04);
   DECLARE @V_VRPERCPGTOFO   FLOAT;
   DECLARE @V_VRPERCPGTOCL   FLOAT;
   DECLARE @V_VRPERCPGTOCL1  FLOAT;
   DECLARE @V_VRPERCPGTOPED  FLOAT;
   DECLARE @V_CDFILIEMIT     VARCHAR(04);
   DECLARE @V_IDCONTAIMPOSTO VARCHAR(01);

   DECLARE @V_COUNT NUMERIC(15,2);
   DECLARE @V_SEQUENCIALST   INTEGER;

   DECLARE @V_VRTOTIMPONF FLOAT;
   DECLARE @V_VRTOTIMPONFPR NUMERIC(15,2);

   SET @V_VRNOTAFISC     = 0;
   SET @V_ORIGDESTNF     = NULL;
   SET @V_ENTRSAIDOP     = NULL;
   SET @V_CDINTEGRACAO   = NULL;
   SET @V_VRIMPORETI     = 0;
   SET @V_CDFILIALPED    = NULL;
   SET @V_NRPEDIDO       = NULL;
   SET @V_FORMPGTOCL     = NULL;
   SET @V_PARCPGTOCL     = NULL;
   SET @V_CDSERVCONT     = NULL;
   SET @V_DSREFSERVFAT   = NULL;
   SET @V_CDFILIALDUP    = NULL;
   SET @V_NRLANCTODUP    = NULL;
   SET @V_VRCONTARECE    = 0;
   SET @V_NRPARCELAS     = 0;
   SET @V_VRIMPOSRETI    = 0;
   SET @V_ARAJUSTEDUP    = 0;
   SET @V_CDAJUCTREC     = NULL;
   SET @V_VRTOTIMPONF    = 0;
   SET @V_SEQUENCIALST   = 0;
   SET @V_VRTOTIMPONFPR  = 0;
   SET @V_COUNT = 0;

   SELECT @V_VRNOTAFISC   = MAX(VRNOTAFISC),
          @V_ORIGDESTNF   = ISNULL(MAX(IDORIGDESTNF),'C'),
          @V_ENTRSAIDOP   = MAX(IDENTRSAIDOP),
          @V_CDINTEGRACAO = MAX(CDINTEGRACAO),
          @V_CDFILIEMIT   = MAX(CDFILIEMIT)
   FROM NOTAFISCAL
   WHERE (CDFILIAL   = @P_CDFILIAL) AND
         (NRLANCTONF = @P_NRLANCTONF);

   IF (@V_CDINTEGRACAO IS NULL) BEGIN
      SELECT @V_VRIMPORETI = SUM(VRTOTIMPONF)
      FROM IMPOSNFTOT INF, IMPOSTO I
      WHERE (INF.CDFILIAL   = @P_CDFILIAL)   AND
            (INF.NRLANCTONF = @P_NRLANCTONF) AND
            (INF.CDIMPOSTO  = I.CDIMPOSTO)   AND
            (I.IDDESCRFONTE <> 'A')          AND
            (I.IDTRATIMPO   = 'R');
   END
   ELSE BEGIN
      SELECT @V_VRIMPORETI = ISNULL(SUM(IT.VRIMPOSTOT), 0)
      FROM TRABIMPOSNFTOT IT, IMPOSTO I
      WHERE (I.CDIMPOSTO     = IT.CDIMPOSTOT) AND
            (IT.CDFILIMPTOT  = @P_CDFILIAL)    AND
            (IT.NRLANCIMPTOT = @P_NRLANCTONF)  AND
            (I.IDDESCRFONTE  <> 'A')          AND
            (I.IDTRATIMPO    = 'R');
   END;

   IF (@V_VRIMPORETI IS NULL) BEGIN
      SET @V_VRIMPORETI = 0;
   END;

   SET @V_VRNOTAFISC = ROUND(@V_VRNOTAFISC - @V_VRIMPORETI,2);

   IF (@V_ENTRSAIDOP = 'S') BEGIN
      SELECT @V_CDFILIALPED = MAX(I.CDFILIALPED),
             @V_NRPEDIDO = MAX(NRPEDIDO)
      FROM ITEMPRODUTO I
      WHERE (I.CDFILIAL   = @P_CDFILIAL) AND
            (I.NRLANCTONF = @P_NRLANCTONF);
   END
   ELSE BEGIN
      SET @V_CDFILIALPED = NULL;
   END;

   IF (@V_CDFILIALPED IS NULL) BEGIN
      IF (@V_ORIGDESTNF = 'F') BEGIN
         SELECT @V_FORMPGTOCL = MAX(F.IDTPFORPGTFO),
         		 @V_PARCPGTOCL = MAX(F.NRPARCPGTOFO)
         FROM FORNECEDOR F
         WHERE F.CDFORNECED = @P_CDCLIENTE;
      END
      ELSE IF (@V_ORIGDESTNF = 'U') BEGIN
         SELECT @V_CDSERVCONT = MAX(CDSERVCONT),
                @V_DSREFSERVFAT = MAX(DSREFSERVFAT)
         FROM SERVFATU
         WHERE (CDFILIAL   = @P_CDFILIAL) AND
               (NRLANCTONF = @P_NRLANCTONF);

         SELECT @V_FORMPGTOCL = MAX(S.IDTPFORPGTSC),
                @V_PARCPGTOCL = MAX(S.NRPARCPGTOSC)
         FROM SERVCONTRAT S
         WHERE (S.CDCLIENTE  = @P_CDCLIENTE) AND
               (S.CDSERVCONT = @V_CDSERVCONT);
      END
      ELSE BEGIN
         SELECT @V_FORMPGTOCL = MAX(C.IDTPFORPGTCL),
                @V_PARCPGTOCL = MAX(C.NRPARCPGTOCL)
         FROM CLIENTE C
         WHERE (C.CDCLIENTE = @P_CDCLIENTE);
      END;
   END
   ELSE BEGIN
      SELECT @V_FORMPGTOCL = MAX(P.IDTPFORPGTPED),
             @V_PARCPGTOCL = MAX(P.NRPARCPGTOPED)
      FROM PEDIDO P
      WHERE (P.CDFILIAL = @V_CDFILIALPED) AND
            (P.NRPEDIDO = @V_NRPEDIDO);
   END;
/* Incluso na tabela de contas a receber de acordo com
   a forma de pagamento do cliente
*/
   SELECT @V_CDFILIALDUP = MAX(CDFILIALDUP),
          @V_NRLANCTODUP = MAX(NRLANCTODUP)
   FROM CONTARECEBER
   WHERE (CDFILIAL   = @P_CDFILIAL) AND
         (NRLANCTONF = @P_NRLANCTONF);

   IF (@V_NRLANCTODUP IS NOT NULL) BEGIN
      SELECT @V_VRCONTARECE = SUM(VRATUAREC)
      FROM CONTARECEBER
      WHERE (CDFILIAL   = @P_CDFILIAL) AND
            (NRLANCTONF = @P_NRLANCTONF);

      UPDATE DUPLICATA
      SET VRDUPLICATA = VRDUPLICATA - @V_VRCONTARECE
      WHERE (CDFILIAL    = @V_CDFILIALDUP) AND
            (NRLANCTODUP = @V_NRLANCTODUP);
   END;

   DELETE FROM CONTARECEBER
   WHERE (CDFILIAL   = @P_CDFILIAL) AND
         (NRLANCTONF = @P_NRLANCTONF);

   /*BUSCA  VALOR DO IMPOSTO ACRESCER PARA SOMAR NA PRIMEIRA PARCELA */
  SELECT @V_VRTOTIMPONFPR = ISNULL(SUM(N.VRTOTIMPONF), 0)
    FROM IMPOSNFTOT N, IMPOSTO I
   WHERE N.CDFILIAL    = @P_CDFILIAL
     AND N.NRLANCTONF  = @P_NRLANCTONF
     AND N.CDIMPOSTO   = I.CDIMPOSTO
     AND I.IDTRATIMPO  = 'A'
     AND IDGERAPARCFIN = 'P';

   /*BUSCA SE EXISTE ALGUEM IMPOSTO ACRESCER PARA GERAR PARCELA SEPADARA*/
   SELECT @V_COUNT = COUNT(1)
     FROM IMPOSNFTOT IT, IMPOSTO I
    WHERE IT.CDFILIAL     = @P_CDFILIAL
      AND IT.NRLANCTONF   = @P_NRLANCTONF
      AND IT.CDIMPOSTO    = I.CDIMPOSTO
      AND I.IDTRATIMPO    = 'A'
      AND I.IDGERAPARCFIN = 'S';

   IF (@V_ENTRSAIDOP = 'S') AND (@V_COUNT > 0) BEGIN
      SELECT @V_VRTOTIMPONF = SUM(ISNULL(N.VRTOTIMPONF, 0))
        FROM IMPOSNFTOT N, IMPOSTO I
       WHERE N.CDFILIAL    = @P_CDFILIAL
         AND N.NRLANCTONF  = @P_NRLANCTONF
         AND N.CDIMPOSTO   = I.CDIMPOSTO
         AND I.IDTRATIMPO  = 'A'
         AND IDGERAPARCFIN = 'S';

      IF @V_VRTOTIMPONF <> 0 BEGIN
         SET @V_SEQUENCIALST = 1;
         SET @V_VRPARCVENC = @V_VRTOTIMPONF;

         INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR, CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                   NRPARCELAREC, QTDIASVENREC, DTORIGVENREC, VRORIGREC, DTATUAVENREC, VRATUAREC,
                                   IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                           VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL, NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL), 2),
                                  '00', 0, NULL, @V_VRPARCVENC, NULL, @V_VRPARCVENC,
                                  'A' , NULL, NULL, NULL, 'S');
      END;
   END;

   SET @V_SEQUENCIAL = 1;

   IF (@V_FORMPGTOCL IS NULL) BEGIN /*Sem forma de pagamento definida*/
      SET @V_VRNOTAFISC = @V_VRNOTAFISC - @V_VRTOTIMPONF;
      INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR, CDMOTIPARC,
                                CDTPCTRECEB, NRSEQVENREC, NRPARCELAREC, QTDIASVENREC,
                                DTORIGVENREC, VRORIGREC, DTATUAVENREC, VRATUAREC,
                                IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                        VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL, NULL,
                                NULL, '01', '00', 0,
                                NULL, @V_VRNOTAFISC, NULL, @V_VRNOTAFISC,
                                'A', NULL, NULL, NULL, 'N');
   END
   ELSE IF (@V_FORMPGTOCL = 'F') BEGIN /*Forma de pagamento fixa*/
      SET @V_VRNOTAFISC = @V_VRNOTAFISC - @V_VRTOTIMPONF;
      IF (@V_PARCPGTOCL = 1) BEGIN
         INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR, CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                   NRPARCELAREC, QTDIASVENREC, DTORIGVENREC, VRORIGREC, DTATUAVENREC, VRATUAREC,
                                   IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                           VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL, NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL+@V_SEQUENCIALST), 2),
                                   '00', 0, NULL, @V_VRPARCVENC, NULL, @V_VRPARCVENC,
                                   'A' , NULL, NULL, NULL, @V_IDCONTAIMPOSTO);

      END
      ELSE BEGIN
         IF (@V_ENTRSAIDOP = 'S') BEGIN
            SET @V_VRPARCVENC = ROUND(@V_VRNOTAFISC/@V_PARCPGTOCL, 2);
            SET @V_VRNOTAFISC = @V_VRNOTAFISC - @V_VRTOTIMPONFPR;
            WHILE (@V_SEQUENCIAL <= @V_PARCPGTOCL) BEGIN
               IF (@V_SEQUENCIAL = @V_PARCPGTOCL) BEGIN
                  SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND(@V_VRNOTAFISC - (@V_VRPARCVENC * @V_PARCPGTOCL), 2);
               END;

               INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                         CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                         NRPARCELAREC, QTDIASVENREC, DTORIGVENREC,
                                         VRORIGREC, DTATUAVENREC, VRATUAREC,
                                         IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
               VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                       NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL+@V_SEQUENCIALST), 2),
                       '00', 0, NULL,
                        ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC  END, 2), NULL,
                        ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2),
                       'A', NULL, NULL, NULL, 'N');
               SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
            END;
         END
      END;
   END
   ELSE BEGIN /*Forma de pagamento varivel*/
      IF (@V_CDFILIALPED IS NULL) BEGIN
         IF (@V_ORIGDESTNF = 'F') BEGIN
            SELECT @V_NRPARCELAS = COUNT(*)
            FROM PRAZOPGTFORN
            WHERE CDFORNECED = @P_CDCLIENTE;
         END
         ELSE IF (@V_ORIGDESTNF = 'U') BEGIN
            SELECT @V_NRPARCELAS = COUNT(*)
            FROM PZPGSERCONT
            WHERE CDCLIENTE  = @P_CDCLIENTE AND
                  CDSERVCONT = @V_CDSERVCONT;
         END
         ELSE BEGIN
            SELECT @V_NRPARCELAS = COUNT(*)
            FROM PRAZOPGTCLIE
            WHERE CDCLIENTE = @P_CDCLIENTE;
         END;
      END
      ELSE BEGIN
         SELECT @V_NRPARCELAS = COUNT(*)
         FROM PRAZOPGTOPED P
         WHERE P.CDFILIAL = @V_CDFILIALPED AND
               P.NRPEDIDO = @V_NRPEDIDO;
      END;

      IF (@V_NRPARCELAS = 1) BEGIN    /* UMA PARCELA */
         INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR, CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                   NRPARCELAREC, QTDIASVENREC, DTORIGVENREC, VRORIGREC, DTATUAVENREC, VRATUAREC,
                                   IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                           VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL, NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL+@V_SEQUENCIALST), 2),
                                   '00', 0, NULL, @V_VRPARCVENC, NULL, @V_VRPARCVENC,
                                   'A' , NULL, NULL, NULL, 'N');
      END
      ELSE BEGIN      /*MAIS DE UMA PARCELA*/
         SET @V_SEQUENCIAL = 1;
         SET @V_VRPARCAUXI = 0;
         SET @V_VRNOTAFISC = @V_VRNOTAFISC - @V_VRTOTIMPONF - @V_VRTOTIMPONFPR;

         IF (@V_CDFILIALPED IS NULL) BEGIN
            IF (@V_ORIGDESTNF = 'F') BEGIN
               DECLARE C_PARCELAS CURSOR FOR
               SELECT VRPERCPGTOFO
               FROM PRAZOPGTFORN
               WHERE (CDFORNECED = @P_CDCLIENTE);
               OPEN C_PARCELAS;
               FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOFO/100)), 2);
                  SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

                  IF (@V_ENTRSAIDOP = 'S') AND (@V_COUNT > 0) AND (@V_VRTOTIMPONF <> 0) BEGIN
                     IF (@V_SEQUENCIAL - 1) = @V_NRPARCELAS BEGIN
                        SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                     END;
                  END
                  ELSE IF @V_SEQUENCIAL = @V_NRPARCELAS BEGIN
                     SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                  END;

                  INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                            CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                            NRPARCELAREC, QTDIASVENREC, DTORIGVENREC,
                                            VRORIGREC, DTATUAVENREC, VRATUAREC,
                                            IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                  VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                          NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL), 2),
                          '00', 0, NULL,
                          ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2), NULL, 
                          ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC  END, 2),
                          'A', NULL, NULL, NULL, 'N');
                  SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
                  FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO;
               END;
               CLOSE C_PARCELAS;
               DEALLOCATE C_PARCELAS;
            END
            ELSE IF (@V_ORIGDESTNF = 'U') BEGIN
               DECLARE C_PARCELAS CURSOR FOR
               SELECT VRPERCPGTOSC AS VRPERCPGTOCL
               FROM PZPGSERCONT
               WHERE (CDCLIENTE  = @P_CDCLIENTE) AND
                     (CDSERVCONT = @V_CDSERVCONT);
               OPEN C_PARCELAS;
               FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOCL;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOCL/100)), 2);
                  SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

                  IF @V_SEQUENCIAL = @V_NRPARCELAS BEGIN
                     SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                  END;

                  INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                            CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                            NRPARCELAREC, QTDIASVENREC, DTORIGVENREC,
                                            VRORIGREC, DTATUAVENREC, VRATUAREC,
                                            IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                  VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                          NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL), 2),
                          '00', 0, NULL,
                          ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2), NULL,
                          ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2),
                          'A', @V_DSREFSERVFAT, NULL, NULL, 'N');
                  SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
                  FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO;
               END;
               CLOSE C_PARCELAS;
               DEALLOCATE C_PARCELAS;
            END
            ELSE BEGIN
               DECLARE C_PARCELAS CURSOR FOR
               SELECT VRPERCPGTOCL
               FROM PRAZOPGTCLIE
               WHERE (CDCLIENTE = @P_CDCLIENTE)
               OPEN C_PARCELAS;
               FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOCL1;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOCL1/100)), 2);
                  SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

                  IF (@V_ENTRSAIDOP = 'S') AND (@V_COUNT > 0) AND (@V_VRTOTIMPONF <> 0) BEGIN
                     IF (@V_SEQUENCIAL - 1) = @V_NRPARCELAS BEGIN
                        SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                     END;
                  END
                  ELSE IF @V_SEQUENCIAL = @V_NRPARCELAS BEGIN
                     SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                  END;

                  INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                            CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                            NRPARCELAREC, QTDIASVENREC, DTORIGVENREC,
                                            VRORIGREC, DTATUAVENREC, VRATUAREC,
                                            IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
                  VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                          NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL),2),
                          '00', 0, NULL,
                           ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2), NULL,
                           ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2),
                          'A', NULL, NULL, NULL, 'N');

                  SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
                  FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO;
               END;
               CLOSE C_PARCELAS;
               DEALLOCATE C_PARCELAS;
            END;
         END
         ELSE BEGIN
            DECLARE C_PARCELAS CURSOR FOR
            SELECT VRPERCPGTOPED
            FROM PRAZOPGTOPED P
            WHERE (P.CDFILIAL = @V_CDFILIALPED) AND
                  (P.NRPEDIDO = @V_NRPEDIDO)
            OPEN C_PARCELAS;
            FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOPED;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRPARCVENC = ROUND((@V_VRNOTAFISC * (@V_VRPERCPGTOPED/100)), 2);
               SET @V_VRPARCAUXI = @V_VRPARCAUXI + @V_VRPARCVENC;

               IF (@V_ENTRSAIDOP = 'S') AND (@V_COUNT > 0) AND (@V_VRTOTIMPONF <> 0) BEGIN
                  IF (@V_SEQUENCIAL - 1) = @V_NRPARCELAS BEGIN
                     SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
                     
                  END;
               END
               ELSE IF @V_SEQUENCIAL = @V_NRPARCELAS BEGIN
                  SET @V_VRPARCVENC = @V_VRPARCVENC + ROUND((@V_VRNOTAFISC - @V_VRPARCAUXI),2);
               END;

               INSERT INTO CONTARECEBER (CDFILIAL, NRLANCTONF, CDMOTIPROR,
                                         CDMOTIPARC, CDTPCTRECEB, NRSEQVENREC,
                                         NRPARCELAREC, QTDIASVENREC, DTORIGVENREC,
                                         VRORIGREC, DTATUAVENREC, VRATUAREC,
                                         IDSTATREC, DSCONTAREC, CDFILIBOLREC, NRLANBOLREC, IDCONTAIMPOSTO)
               VALUES (@P_CDFILIAL, @P_NRLANCTONF, NULL,
                       NULL, NULL, RIGHT('00'+CONVERT(VARCHAR, @V_SEQUENCIAL),2),
                       '00', 0, NULL,
                        ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2), NULL,
                        ROUND(CASE @V_SEQUENCIAL WHEN 1 THEN @V_VRPARCVENC + @V_VRTOTIMPONFPR ELSE @V_VRPARCVENC END, 2),
                       'A', NULL, NULL, NULL, 'N');

               SET @V_SEQUENCIAL = @V_SEQUENCIAL + 1;
               FETCH NEXT FROM C_PARCELAS INTO @V_VRPERCPGTOFO;
            END;
         END;
      END;
   END;

   IF (@V_NRLANCTODUP IS NOT NULL) BEGIN
      UPDATE CONTARECEBER
      SET CDFILIALDUP = @V_CDFILIALDUP,
          NRLANCTODUP = @V_NRLANCTODUP
      WHERE (CDFILIAL   = @P_CDFILIAL) AND
            (NRLANCTONF = @P_NRLANCTONF);

      SELECT @V_VRCONTARECE = SUM(VRATUAREC)
      FROM CONTARECEBER
      WHERE (CDFILIAL   = @P_CDFILIAL) AND
            (NRLANCTONF = @P_NRLANCTONF);

      UPDATE DUPLICATA
      SET VRDUPLICATA = VRDUPLICATA + @V_VRCONTARECE
      WHERE (CDFILIAL    = @V_CDFILIALDUP) AND
            (NRLANCTODUP = @V_NRLANCTODUP);

      SELECT @V_VRIMPOSRETI = ISNULL(SUM(IT.VRIMPOSTOT),0)
      FROM TRABIMPOSNFTOT IT, IMPOSTO I
      WHERE (I.CDIMPOSTO     = IT.CDIMPOSTOT) AND
            (IT.CDFILIMPTOT  = @P_CDFILIAL)   AND
            (IT.NRLANCIMPTOT = @P_NRLANCTONF) AND
            (I.IDDESCRFONTE  <> 'A')          AND
            (I.IDTRATIMPO    = 'R');

      SELECT @V_ARAJUSTEDUP = ISNULL(MAX(A.VRAJDUPBOLET),0),
             @V_CDAJUCTREC = MAX(T.CDAJUCTREC)
      FROM AJDUPBOLET A, TIPOAJRECEBER T
      WHERE (A.CDFILIAL    = @V_CDFILIALDUP) AND
            (A.NRLANCTODUP = @V_NRLANCTODUP) AND
            (A.CDAJUCTREC  = T.CDAJUCTREC)   AND
            (T.IDAJUCTREC  = 'D');

      IF (@V_ARAJUSTEDUP > 0) BEGIN
         IF (@V_ARAJUSTEDUP > @V_VRIMPOSRETI) BEGIN
            UPDATE AJDUPBOLET
            SET VRAJDUPBOLET = VRAJDUPBOLET - @V_VRIMPOSRETI
            WHERE (CDFILIAL    = @V_CDFILIALDUP) AND
                  (NRLANCTODUP = @V_NRLANCTODUP) AND
                  (CDAJUCTREC  = @V_CDAJUCTREC);
			END
         ELSE IF (@V_ARAJUSTEDUP = @V_VRIMPOSRETI) BEGIN
            DELETE FROM AJDUPBOLET
            WHERE (CDFILIAL    = @V_CDFILIALDUP) AND
                  (NRLANCTODUP = @V_NRLANCTODUP) AND
                  (CDAJUCTREC  = @V_CDAJUCTREC);
         END;
      END;
   END;
END;
GO         

-- VERSAO --
EXEC ATUVEROBJ 'APURAC_VENC','5.60.xxx';
GO
